package de.ctdo.bunti.dao;

import de.ctdo.bunti.model.Room;
import org.springframework.stereotype.Repository;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;

@Repository
public final class RoomsDAOImpl implements RoomsDAO {
    private EntityManager em;

    @PersistenceContext
    public void setEntityManager(EntityManager entityManager) {
        this.em = entityManager;
    }

    @Override
    public List<Room> getRooms() {
        return em.createQuery("SELECT r FROM Room r").getResultList();
    }

    @Override
    public Room getRoom(int id) {
        return em.find(Room.class, id);
    }

    @Override
    public void addRoom(Room room) {
        em.persist(room);
    }

    @Override
    public void removeRoom(int id) {
        em.remove(getRoom(id));
    }
}
